/*
Copyright 2015 Red Hat, Inc. and/or its affiliates.
 */
#ifndef SHARE_VM_GC_SHENANDOAH_SHENANDOAHJNICRITICAL_HPP
#define SHARE_VM_GC_SHENANDOAH_SHENANDOAHJNICRITICAL_HPP

#include "gc/shared/vmGCOperations.hpp"
#include "memory/allocation.hpp"

class ShenandoahJNICritical : public CHeapObj<mtGC> {
private:
  VM_Operation* _op_waiting_for_jni_critical;

public:
  ShenandoahJNICritical();
  void notify_jni_critical();
  void set_waiting_for_jni_before_gc(VM_Operation* op);
  void execute_in_vm_thread(VM_Operation* op);
};


#endif // SHARE_VM_GC_SHENANDOAH_SHENANDOAHJNICRITICAL_HPP
